#!/bin/bash

#
# Lecture parametres
#
. $(dirname $0)/config.sh


#
#
# FORMAT / PARTITION
#
#

umount ${card}*
sleep 4s
umount ${card}*


cat <<EOT | sfdisk --in-order -uM ${card}
0,,c
EOT

sleep 4s

mkfs.vfat ${card}${p}1


#
#
# Ecriture
#
#

mount ${card}${p}1 /mnt

dd if=/dev/urandom of=/tmp/testCorupt.fich bs=1M count=1

compteur=0
result=0

while [ $result -eq 0 ]; do
	echo "Ecriture bloc $compteur"
	cp /tmp/testCorupt.fich "/mnt/"$compteur".testCorupt.fich"
	result=$?
	compteur=$(echo $compteur + 1 | bc)
done

stop=$compteur

umount ${card}${p}1
sync

#
#
# Lecture / comparaison
#
#

mount ${card}${p}1 /mnt

compteur=0
result=0
blocsOk=0
blocErr=0

stop=3801

controle=$(md5sum /tmp/testCorupt.fich | grep -o "^[^ ]*" )

echo [ $compteur -lt $stop ]
while [ $compteur -lt $stop ]; do
	sommeTest=$(md5sum "/mnt/"$compteur".testCorupt.fich" | grep -o "^[^ ]*" )
	if [ "$sommeTest" == "$controle" ]; then
		echo "$compteur: OK";
		blocsOk=$(echo $blocsOk + 1 | bc)
	else
		echo "$compteur: Erreur $sommeTest / $controle";
		blocErr=$(echo $blocErr + 1 | bc)
	fi
	compteur=$(echo $compteur + 1 | bc)
done

totalBlocs=$(echo $blocsOk + $blocErr | bc)
echo "blocs OK = $blocsOk ("$(echo "scale=2; ( $blocsOk * 100 ) / $totalBlocs" | bc )"%)"
echo "blocs Err = $blocErr ("$(echo "scale=2; ( $blocErr * 100 ) / $totalBlocs" | bc )"%)"
echo "total = totalBlocs"

